<?PHP
/***************************** isend.php ************************* 2016-08-19 AF
* Put message in database and mail if needed
*******************************************************************************/

define('_ISEND_', 1 );

// check if email address is valid
function is_email($email){
  return eregi('^[a-z0-9\.\-_&$\+\*!",|%]+@[a-z0-9\-]+([\.:][a-z0-9\-]+)+$', $email);}


// Does various checks on new message data.
// Returns an empty string if ok, and an error message if a problem exists.
function check_data($host, &$author, &$subject, &$email) {
  global $lNoAuthor, $lNoSubject, $lNoEmailReply, $lViolation,
  $Password, $ModPass, $email_reply, $CommonAbsDir, $ext, $similarity;

  $author = substr(trim($author), 0, 50);
  $subject = substr(trim($subject), 0, 50);
  $email = substr(trim($email), 0, 100);

  $author = preg_replace('/<\/?[^>]>|[\x00-\x1F]/', '', $author);
  $subject = preg_replace('/<\/?[^>]>|[\x00-\x1F]/', '', $subject);

  $IsError = '';
  if (empty($author)) {$IsError=$lNoAuthor . ' ';}
  if (empty($subject)){$IsError.=$lNoSubject;}
  if ($IsError) {return $IsError;}

  if(empty($email)) {
    $email = '';}
  else {
    $email = ereg_replace('\([^\)]*\)', '', $email);   // remove anything in ()
    $email = ereg_replace('.*<([^>]+)>.*', '\1', $email); // extract anything in <>
    $email = trim($email);
    if (!is_email($email)) {$email = '';}}

  if(empty($email) && $email_reply){
    $IsError = $lNoEmailReply; $email_reply = '';}

  // search for blacklist file
  $blacklist = "blacklist.$ext";
  if (file_exists($blacklist)) {
    include $blacklist;}
  else {
    $blacklist = "$CommonAbsDir/$blacklist";
    if (file_exists($blacklist)) {
      include $blacklist;}
    else {
      $blacklist = '';}}
  if ($blacklist) {
    // search for blacklisted authors
    if (is_array($banned_authors)) {
      $n = count($banned_authors);
      for ($i = 0; $i < $n; $i++) {
        if (similar_text(strtolower($author),strtolower($banned_authors[$i]),$pct) > 1
        && $pct > $similarity || eregi($banned_authors[$i], $author)) {
          $IsError = $lViolation;}}}

    if (is_array($banned_emails)) {
      $n = count($banned_emails);
      for ($i = 0; $i < $n; $i++) {
        if (strtolower($email) == strtolower($banned_emails[$i])) {
          $IsError = $lViolation;}}}

    if (is_array($banned_hosts)) {
      $n = count($banned_hosts);
      for ($i = 0; $i < $n; $i++) {
        if ($host == $banned_hosts[$i]) {
          $IsError = $lViolation;}}}}

  return($IsError);}


// Check for duplicate message
function check_dup() {
  global $qq, $DB, $BoardTableName, $msgid, $id, $thread, $body;
  $sSQL="Select id, thread from $BoardTableName where msgid='$msgid'";
  $qq->query($DB, $sSQL);
  $row=$qq->getrow(); $n=0;
  while(is_array($row)){
    // message(s) with same msgid found
    $same[$n]['id'] = $row['id'];
    $same[$n]['thread'] = $row['thread'];
    $row=$qq->getrow(); $n++;}
  for ($i=0; $i<$n; $i++) {
    $dup_id = $same[$i]['id'];
    $sSQL="Select body from $BoardTableName"."_bodies where id='$dup_id'";
    $qq->query($DB, $sSQL);
    $row=$qq->getrow();
    if (isset($row['body']) && $row['body']==stripslashes($body)) {
      // yes, it is the same message
      $id=$same[$i]['id'];; $thread=$same[$i]['thread'];
      return true;}}
  // It is not the same message (User must have pressed back button and edit to make new message)
  // Note: this allows several messages with the same msgid, but the id is unique.
  return false;}


// Expire old messages. Expiry goes in two steps:
// A message is hidden when the expiry date is passed for the message and all its descendants.
// A thread is deleted when all messages in the thread has expired $BoardExpiry2 days ago.
function expire_old_messages(){
  global $DB, $BoardTableName, $thread, $parent, $BoardExpiry2;
  $d1 = date('Y-m-d'); $dd = date('Ymd');
  $d2 = date('Ymd', time() - 86400*$BoardExpiry2);

  // find threads where expiry date of at least one message in thread is passed
  $sSQL = "select distinct thread from $BoardTableName where expires < '$d1' and thread!=$thread";
  $q1 = new query($DB, $sSQL); $q2 = new query($DB);
  while($row=$q1->getrow()){
    $t = $row['thread']; $ToHide = '';
    if ($t) {
      $q2->query($DB, "select max(expires) as max_exp from $BoardTableName where thread = $t");
      $rec = $q2->getrow();
      $max_exp = $rec['max_exp'];
      if ($max_exp && ereg_replace('-','',$max_exp) < $d2) {
        // Second step expiry: delete thread
        $q2->query($DB, "delete from $BoardTableName where thread = $t");
        $q2->query($DB, "delete from $BoardTableName"."_bodies where thread = $t");
        continue;}

      // First step expiry: hide messages if message and all descendants expired
      $q2->query($DB, "select id, parent, expires from $BoardTableName where thread = $t order by id desc");
      while($rec=$q2->getrow()){
        $i = $rec['id'];
        if (ereg_replace('-','',$rec['expires']) < $dd && empty($HasDescendents[$i])) {
          $ToHide .= $i . ',';}
        else {
          $HasDescendents[$rec['parent']] = 1;}}
      $ToHide = substr($ToHide,0,-1);
      if ($ToHide) {
        $q2->query($DB, "update $BoardTableName SET astatus = 0x200 where id in ($ToHide) and ! (astatus & 0x608)");}
      unset ($HasDescendents);}}}


function Encode_quoted_printable ($text) {
  // encode text as quoted-printable for email
  // (same as function imap_8bit, which is not always implemented)
  $text = preg_replace ('/[\x00-\x1F]/', "\n", $text); // convert all control characters to newline
  $text = preg_replace ('/=/', '=3D', $text); // convert '='
  $text = preg_replace ("/([^\n-~])/e", "'='.dechex(ord('\\1'))", $text); // convert ascii values > 0x7F
  return $text;}

function has_html ($text) {
  // Detect if text contains HTML code
  // Returns 3 if <br> or <p> code found (No conversion needed)
  // Returns 1 if other HTML codes found (Only linefeeds need conversion)
  // Returns 0 if no valid HTML codes found (Everything needs conversion)
  
  //if (eregi("<(br>|p>|p[[:space:]]+([[:alnum:]]|[[:space:]]|=|\'[^\']+\'|\"[^\"]+\")*>)", $text)) {
  if (eregi("<((br|p|pre)([[:space:]]+([[:alnum:]]|[[:space:]]|=|\'[^\']*\'|\"[^\"]*\")*)?>)", $text)) {
    return 3;}
  if (eregi("<((a|b|i|p|em|strong|h1|h2|h3|font|table|ol|ul|dl|img)([[:space:]]+([[:alnum:]]|[[:space:]]|=|\'[^\']*\'|\"[^\"]*\")*)?>)", $text)) {
    return 1;}
  return 0;}

function remove_html($text) {
  // convert html to plain text
  $text = eregi_replace("\n", ' ', $text);
  $text = eregi_replace('<br>', "\n", $text);
  $text = eregi_replace('<p(\s[^>]*)?>', "\n\n", $text);
  $text = ereg_replace('<[^>]*>', '', $text);
  $text = ereg_replace('&amp;', '&', $text);
  $text = ereg_replace('&quot;', '"', $text);
  $text = ereg_replace('&lt;', '<', $text);
  $text = ereg_replace('&gt;', '>', $text);
  return $text;}

function remove_forbidden_html($text){
  // Removes any possibly harmful HTML and script codes from text
  global $BoardHTMLban;

  // remove comments
  $text = preg_replace('/<!--(.|\n)*?-->/', '', $text);
  // remove any <head> section
  if (eregi("<head", $text)) {
    $text = eregi_replace("(.|\n)*</head>", '', $text);}
  // remove possibly dangerous HTML codes, including codes specified in $BoardHTMLban (e.g. '|img')
  $text = eregi_replace("</?(script|noscript|form|frameset|frame|iframe|input|button|applet|object|embed|param|server|html|meta|refresh|title|body$BoardHTMLban)[^>]*>", '', $text);
  // remove server side codes
  $text = eregi_replace("<(\?|%|!)[^>]*>", '', $text);
  // remove script links such as <a href="javascript:..> or <img src="vbscript:..>
  $text = eregi_replace('<[[:alpha:]][^>]*=[^>]*script[[:space:]]*:[^>]*>', '', $text);
  // remove event handlers
  $text = eregi_replace("<([[:alpha:]]([^>\'\"]|\'[^\']*\'|\"[^\"]*\")*)[[:space:]]+on[[:alpha:]]+[[:space:]]*=", "<\\1>", $text);
  return $text;}

function convert_to_html($text, $HTMLlevel) {
  // convert plain text to HTML
  // HTMLlevel is the return value from function has_html
  if ($HTMLlevel == 0) {
    $text = htmlspecialchars($text);}
  if ($HTMLlevel < 2) {
    // look for hyperlinks:
    $text = eregi_replace("([[:space:]])http://([a-z0-9\\-]+\\.[^ \n\t]+)",
      "\\1<a href=\"http://\\2\">\\2</a>", $text);
    $text = eregi_replace("([[:space:]])(www(\\.[a-z0-9\\-]+){2,}(/[^ \n\t]*)*)",
      "\\1<a href=\"http://\\2\">\\2</a>", $text);
    $text = eregi_replace("([[:space:]])mailto:([a-z0-9\\-_&;\\+!]+@[^ \n\t]+)",
      "\\1<a href=\"mailto:\\2\">\\2</a>", $text);
    // convert linefeeds
    $text = eregi_replace("\n\n", "<P>", $text);
    $text = eregi_replace("\n", "<BR>\n", $text);}
  return $text;}

// Mail message to users or moderator.
// Message is MIME encoded as multipart/alternative.
// $XtraHeader may contain extra headers, ending with a single \n
function mail_message($recipients, $XtraHeader = '') {
  global $id, $email, $subject, $author, $msgid, $body, $BoardTableName,
  $BoardEmail, $BoardModEmail, $BoardName, $ForumVersion, $ServerName,
  $BoardVirtDir, $read_page, $ext, $header, $mail_style, $mail_print_style,
  $style, $print_style, $leSentFromM, $leSubject, $leAuthor, $leMessage,
  $leModLink, $leModerateForMMessageI, $leMessageboardSubject, $leFromAatM;

  if ($header) {include $header; $header='';}

  if($email){
    $from_email=$email;}
  else {
    $from_email=$BoardModEmail;}

  $PlainSubject = preg_replace('/[\x00-\x1F]/', '', remove_html(stripslashes($subject)));
  $PlainAuthor  = preg_replace('/[\x00-\x1F]/', '', remove_html(stripslashes($author)));

  $ebody = "<HTML><HEAD>\n"
  . "<STYLE type=\"text/css\"><!--\n$mail_style\n--></STYLE>\n"
  . "<STYLE type=\"text/css\" media=\"print\"><!--\n$mail_print_style\n--></STYLE>\n"
  . "</HEAD>\n<BODY>\n"
  . "<TABLE border=\"0\" width=\"100%\" class=\"ttable\">\n"
  . "<TR><TH class=\"ttable\">" . sprintf($leSentFromM,$BoardName) . "</TH></TR>\n"
  . "<TR><TD class=\"subject\">$leSubject: $PlainSubject</TD></TR>\n"
  . "<TR><TD class=\"subject\">$leAuthor: $PlainAuthor</TD></TR>\n"
  . "<TR><TD class=\"nav\"><a href=\"http://$ServerName$BoardVirtDir/$read_page.$ext?i=$id\">$leMessage</a></TD></TR>\n";

  if ($BoardEmail && $recipients == $BoardModEmail) {
    // send to moderator
    $ebody .= "<TR><TD class=\"nav\"><a href=\"http://$ServerName$BoardVirtDir/$read_page.$ext?i=$id&a=edit\">$leModLink</a></TD></TR>\n";
    $etitle = sprintf($leModerateForMMessageI,$BoardName,$PlainSubject);}
  else {
    // send to user
    $etitle = sprintf($leMessageboardSubject,$BoardName,$PlainSubject);}

  $ebody .= "</TABLE>\n<P>";
  $PlainBody = Encode_quoted_printable(stripslashes($body));
  $ebody = Encode_quoted_printable($ebody) . $PlainBody . "</P>\n</BODY></HTML>";
  $PlainBody = remove_html($PlainBody);
  if (function_exists('wordwrap')) { // limit line length
    $PlainBody = wordwrap($PlainBody);
    $ebody = wordwrap($ebody);}
  $boundary = "-=======-";

  $eheaders = 'From: ' . sprintf($leFromAatM,$PlainAuthor,$BoardName) . " <$from_email>\n"
  . "Return-Path: $from_email\n"
  . "Errors-to: $BoardModEmail\n"
  . "X-Mailer: AForum $ForumVersion\n"
  . "Message-ID: <$BoardTableName.$id.$msgid@$ServerName>\n"
  . $XtraHeader
  . "MIME-Version: 1.0\n"
  // . "Content-Type: text/html; charset=iso-8859-1\n";
  . "Content-Type: multipart/alternative;\n\tboundary=\"$boundary\"\n";

  $fbody =
  "This message is in MIME format.\n\n"
  . "--$boundary\n"
  . "Content-Type: text/plain;\n\tcharset=\"iso-8859-1\"\n"
  . "Content-Transfer-Encoding: quoted-printable\n\n"
  . $PlainBody
  . "\n\n--$boundary\n"
  . "Content-Type: text/html;\n\tcharset=\"iso-8859-1\"\n"
  . "Content-Transfer-Encoding: quoted-printable\n\n"
  . $ebody
  . "\n";

  if (strchr($recipients, ',')) {
    // more than one recipient
    $to = '';
    $eheaders .= "Bcc: $recipients\n";}
  else {
    $to = $recipients;}

  mail($to, $etitle, $fbody, $eheaders);}


// Post a message to email.
function post_to_email() {
  global $qq, $DB, $BoardModEmail, $BoardTableName, $BoardName, $BoardEmailReply,
  $email, $thread, $parent, $ServerName, $BoardMailingList, $header;

  $replies='';

  if($thread!=0 && $BoardEmailReply){
    $sSQL = "Select distinct email from $BoardTableName where thread=$thread and email_reply='Y' and email<>'$email'";
    $qq->query($DB, $sSQL);
    if($qq->numrows()>0){
      while($row=$qq->getrow()){
        $replies.=trim($row['email']).',';}
      $replies=substr($replies, 0, -1);}}

   $XtraHeader = '';
   if(!empty($parent)) {
    $qq->query($DB, "Select msgid from $BoardTableName where id='$parent'");
    if($qq->numrows()>0){
      $row=$qq->getrow();
      if (!empty($row['msgid'])) {
        $pmsgid = $row['msgid'];
        $XtraHeader = "In-reply-to: <$BoardTableName.$parent.$pmsgid@$ServerName>\n";}}}

  if ($BoardMailingList) {
    $replies = $replies ? $replies.','.$BoardMailingList : $BoardMailingList;}
  if($replies){
    mail_message($replies, $XtraHeader);}}


// Add a message to database.
// Returns an error message on error, empty string otherwise.
function post_to_database() {
  global $qq, $DB, $BoardTableName, $BoardPreMod, $BoardModEmail, $BoardEmail,
  $BoardName, $more, $ServerName, $BoardVirtDir, $thread, $subject, $inreplyto,
  $parent, $author, $body, $email, $datestamp, $host, $email_reply, $expiry,
  $BoardDefExpiry, $msgid, $read_page, $ext, $id, $moderate, $ModeratorID,
  $lmModLink, $lmSubject, $lmAuthor, $lmMessage, $leFromAatM,
  $lmModerateForMMessageI, $BoardLogFiles, $BoardLogFilePrefix;

  if (empty($thread)) $thread=0;

  // compute expiry date and expire old messages
  $expires='9999-12-31';
  if ($BoardDefExpiry) {
    if ($expiry <= 0) {$expiry=$BoardDefExpiry;}
    $t = time();
    $e = $expiry*86400 + $t; // warning: works only until year 2038!
    if ($e > $t && $e < 0x7FFFFFFF) {
      $expires = date('Y-m-d', $e);}
    expire_old_messages();}

  // add new message to database
  $sSQL = "Insert Into $BoardTableName"."_bodies (id, body, thread) values ('0', '$body', $thread)";
  $qq->query($DB, $sSQL);
  if(!$qq->result){
    return($qq->error());}
  $id=$DB->lastid();
  if($thread==0) {
    $thread=$id;
    $sSQL = "Update $BoardTableName"."_bodies SET thread = id WHERE id = $id";
    $qq->query($DB, $sSQL);
    if(!$qq->result){
      return($qq->error());}}

  if($thread!=$id){
    $more = $thread+1;
    $more = "&a=2&t=$more";}

  $astatus = $BoardPreMod ? 0x480 : 1;  $moderator = '';
  if ($moderate) {$astatus = 5; $moderator = $ModeratorID;}
  $flgs = ($astatus & 0x600) ? 0 : 1;

  $sSQL = "Insert Into $BoardTableName (
  id, author, email, datestamp, expires, subject, host, thread, parent, email_reply, msgid, astatus, flgs, moderator)
  values ('$id', '$author', '$email', '$datestamp', '$expires', '$subject', '$host', '$thread', '$parent', '$email_reply', '$msgid', '$astatus', '$flgs', '$moderator')";
  $qq->query($DB, $sSQL);
  if(!$qq->result){
    return($qq->error());}

  // send to moderator
  if($BoardEmail && !empty($BoardModEmail)){
    mail_message($BoardModEmail);}

  if ($BoardLogFiles & 2) { // write to posting log
    write_log($BoardLogFilePrefix.'post.log', "$id, $thread, $author, $email, exp.$expires");}

  return('');}
?>
